#!/usr/bin/python2

"""    Multipeer, Copyright 2003 Andreas Bergstrm and Audun Vaaler

    This file is part of Multipeer.
    
    Multipeer is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.
    Foobar is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.
    You should have received a copy of the GNU General Public License
    along with Foobar; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA"""

import fnmatch, sha, string, sys

debug = 0

def removeFromSharing(hash):
    try:
        summary = openFile("summary.txt")
    except:
        print "Could not open summary.txt!"

    delLine = checkIfFileExists(["Name: *","Date: *","Category: *","CCategory: *","Desc: *","MIME: *", ("HASH: " + hash.strip()), "length: *"])[0]

    try:
        lines = summary.readlines()
    except:
        print "Could not read from summary txt!"

    hash = hash.strip()
    nl = []

    for line in lines:
        lHash = line.split(";")[6].strip()
        if lHash != hash:
            nl.append(line)

    lines = nl

    try:
        summary.close()
    except:
        print "Error, could not close summary.txt!"

    try:
        summary = open("summary.txt", "w")
    except:
        print "Error, could not open summary text for writing!"

    try:
        for line in lines:
            summary.write(line)
    except:
        print "Error, could not write to summary text!"

    try:
        summary.close()
    except:
        print "Error, could not close summary text after writing!"
    

def checkIfFileExists(searchstring):
    # Load summary file
    try:
        summary = openFile("summary.txt")
    except:
        print "Could not open summary.txt!"
    headings, data = parseFile(summary)
    headers = ["Name", "Date", "Category", "CCategory", "Desc", "MIME", "HASH", "length"]
    retlist = []

    for i in range(0, 8):
        remlen = len(headers[i])
        searchstring[i] = searchstring[i][(remlen + 2):]

    for queryline in data:
        if debug >= 5:
            print "FileLib, checkIfFileExists, queryline: %s" % queryline
        i = 0
        retline = ""
        notfound = 0
        for line in queryline:
            if notfound:
                break
            if retline == "":
                retline = line
            else:
                retline = retline + "; " + line
    
            if not fnmatch.fnmatch(line.strip(), searchstring[i].strip()):
                notfound = 1
                retline = ""
                if debug:
                    print "FileLib, CheckIfFileExists, notfound: %s : %s, %s" % (line.strip(), searchstring[i].strip(), i)
                break
            i += 1
        if retline != "":
            if debug:
                print "FileLib, checkIfFileExists, retline: %s" % retline
            retlist.append(retline)
        
    return retlist

def getFile(hash):
    try:
        summary = openFile("summary.txt")
    except:
        print "Could not open summary.txt"
        return None

    headings, data = parseFile(summary)
    for line in data:
         if line[6].strip() == hash.strip():
            path = "files/" + line[0].strip()
            return openFile(path), line[7]

    print "Error, could not find requested file!"
    return None

def openFile(path):
    try:
        file = open(path)
    except IOError, msg:
        print "Error, could not open file: %s !" % path
        print msg
        return None

    return file

def parseFile(file):
    fileheader = file.readline()
    filedata = file.readlines()
    file.close()

    headings = string.split(fileheader, ";\n")

    data = []
    for line in filedata:
        data.append(string.split(line, ";"))

    return headings, data

def Encode(s):
    s = s.replace(";", "<!*sk*!>")
    s = s.replace("\n", "<!*nl*!>")
    return s

def Decode(s):
    s = s.replace("<!*sk*!>", ";")
    s = s.replace("<!*nl*!>", "\n")
    return s
